local e=require"luci.passwall.api"
local a=e.appname
local t=e.fs
local h=e.is_finded("v2ray")
local i=e.is_finded("xray")
local n=e.is_finded("fw3")
local e=e.is_finded("fw4")
m=Map(a)
s=m:section(TypedSection,"global_delay",translate("Delay Settings"))
s.anonymous=true
s.addremove=false
o=s:option(Value,"start_delay",translate("Delay Start"),
translate("Units:seconds"))
o.default="1"
o.rmempty=true
o=s:option(Flag,"start_daemon",translate("Open and close Daemon"))
o.default=1
o.rmempty=false
s=m:section(TypedSection,"global_forwarding",
translate("Forwarding Settings"))
s.anonymous=true
s.addremove=false
o=s:option(Value,"tcp_no_redir_ports",translate("TCP No Redir Ports"))
o.default="disable"
o:value("disable",translate("No patterns are used"))
o:value("1:65535",translate("All"))
o=s:option(Value,"udp_no_redir_ports",translate("UDP No Redir Ports"),
"<font color='red'>"..translate(
"Fill in the ports you don't want to be forwarded by the agent, with the highest priority.")..
"</font>")
o.default="disable"
o:value("disable",translate("No patterns are used"))
o:value("1:65535",translate("All"))
o=s:option(Value,"tcp_proxy_drop_ports",translate("TCP Proxy Drop Ports"))
o.default="disable"
o:value("disable",translate("No patterns are used"))
o=s:option(Value,"udp_proxy_drop_ports",translate("UDP Proxy Drop Ports"))
o.default="80,443"
o:value("disable",translate("No patterns are used"))
o:value("80,443",translate("QUIC"))
o=s:option(Value,"tcp_redir_ports",translate("TCP Redir Ports"))
o.default="22,25,53,143,465,587,853,993,995,80,443"
o:value("1:65535",translate("All"))
o:value("22,25,53,143,465,587,853,993,995,80,443",translate("Common Use"))
o:value("80,443",translate("Only Web"))
o=s:option(Value,"udp_redir_ports",translate("UDP Redir Ports"))
o.default="1:65535"
o:value("1:65535",translate("All"))
o:value("53","DNS")
o=s:option(ListValue,"use_nft",translate("Firewall tools"))
o.default="0"
if n then
o:value("0","IPtables")
end
if e then
o:value("1","NFtables")
end
if(os.execute("lsmod | grep -i REDIRECT >/dev/null")==0 and os.execute("lsmod | grep -i TPROXY >/dev/null")==0)or(os.execute("lsmod | grep -i nft_redir >/dev/null")==0 and os.execute("lsmod | grep -i nft_tproxy >/dev/null")==0)then
o=s:option(ListValue,"tcp_proxy_way",translate("TCP Proxy Way"))
o.default="redirect"
o:value("redirect","REDIRECT")
o:value("tproxy","TPROXY")
o:depends("ipv6_tproxy",false)
o=s:option(ListValue,"_tcp_proxy_way",translate("TCP Proxy Way"))
o.default="tproxy"
o:value("tproxy","TPROXY")
o:depends("ipv6_tproxy",true)
o.write=function(a,e,t)
return a.map:set(e,"tcp_proxy_way",t)
end
if os.execute("lsmod | grep -i ip6table_mangle >/dev/null")==0 or os.execute("lsmod | grep -i nft_tproxy >/dev/null")==0 then
o=s:option(Flag,"ipv6_tproxy",translate("IPv6 TProxy"),
"<font color='red'>"..translate(
"Experimental feature. Make sure that your node supports IPv6.")..
"</font>")
o.default=0
o.rmempty=false
end
end
o=s:option(Flag,"accept_icmp",translate("Hijacking ICMP (PING)"))
o.default=0
o=s:option(Flag,"accept_icmpv6",translate("Hijacking ICMPv6 (IPv6 PING)"))
o:depends("ipv6_tproxy",true)
o.default=0
if h or i then
o=s:option(Flag,"sniffing",translate("Sniffing (V2Ray/Xray)"),translate("When using the V2ray/Xray shunt, must be enabled, otherwise the shunt will invalid."))
o.default=1
o.rmempty=false
if i then
route_only=s:option(Flag,"route_only",translate("Sniffing Route Only (Xray)"),translate("When enabled, the server not will resolve the domain name again."))
route_only.default=0
route_only:depends("sniffing",true)
local e=string.format("/usr/share/%s/rules/domains_excluded",a)
o=s:option(TextValue,"no_sniffing_hosts",translate("No Sniffing Lists"),translate("Hosts added into No Sniffing Lists will not resolve again on server (Xray only)."))
o.rows=15
o.wrap="off"
o.cfgvalue=function(a,a)return t.readfile(e)or""end
o.write=function(i,i,a)t.writefile(e,a:gsub("\r\n","\n"))end
o.remove=function(i,a,i)
if route_only:formvalue(a)=="0"then
t.writefile(e,"")
end
end
o:depends({sniffing=true,route_only=false})
o=s:option(Value,"buffer_size",translate("Buffer Size (Xray)"),translate("Buffer size for every connection (kB)"))
o.rmempty=true
o.datatype="uinteger"
end
end
return m
