local r,a=...
local h=require"luci.passwall.api"
if not h.is_finded("xray")and not h.is_finded("v2ray")then
return
end
local m=h.appname
local c=h.uci
local e="xray_"
local function t(t)
return e..t
end
local function s(t,a)
if t.option:find(e)==1 then
return r:get(a,t.option:sub(1+#e))
end
end
local function n(t,a,o)
if t.option:find(e)==1 then
r:set(a,t.option:sub(1+#e),o)
end
end
local function p(t,a,o)
if t.option:find(e)==1 then
r:del(a,t.option:sub(1+#e))
end
end
local function t(o,e,a)
local t={type="Xray"}
if e then
if type(e)=="string"then
t[e]=a
else
for a,e in pairs(e)do
t[a]=e
end
end
end
o:depends(t)
end
local function i(a,e,o)
local t={type="V2ray"}
if e then
if type(e)=="string"then
t[e]=o
else
for e,a in pairs(e)do
t[e]=a
end
end
end
a:depends(t)
end
local y={
"aes-128-gcm","aes-256-gcm","chacha20-poly1305"
}
local f={
"aes-128-gcm","aes-256-gcm","chacha20-poly1305","xchacha20-poly1305","2022-blake3-aes-128-gcm","2022-blake3-aes-256-gcm","2022-blake3-chacha20-poly1305"
}
local w={"none","auto","aes-128-gcm","chacha20-poly1305","zero"}
local u={
"none","srtp","utp","wechat-video","dtls","wireguard"
}
if h.is_finded("xray")then
a.fields["type"]:value("Xray",translate("Xray"))
end
if h.is_finded("v2ray")then
a.fields["type"]:value("V2ray",translate("V2ray"))
end
o=a:option(ListValue,"xray_protocol",translate("Protocol"))
o:value("vmess",translate("Vmess"))
o:value("vless",translate("VLESS"))
o:value("http",translate("HTTP"))
o:value("socks",translate("Socks"))
o:value("shadowsocks",translate("Shadowsocks"))
o:value("trojan",translate("Trojan"))
o:value("wireguard",translate("WireGuard"))
o:value("_balancing",translate("Balancing"))
o:value("_shunt",translate("Shunt"))
o:value("_iface",translate("Custom Interface").." (Only Support Xray)")
t(o)
i(o)
o.cfgvalue=s
o.write=n
o=a:option(Value,"xray_iface",translate("Interface"))
o.default="eth1"
t(o,{xray_protocol="_iface"})
o.cfgvalue=s
o.write=n
local o={}
local d={}
local l={}
for t,e in ipairs(h.get_valid_nodes())do
if e.node_type=="normal"then
o[#o+1]={
id=e[".name"],
remarks=e["remark"]
}
end
if e.protocol=="_balancing"then
d[#d+1]={
id=e[".name"],
remarks=e["remark"]
}
end
if e.protocol=="_iface"then
l[#l+1]={
id=e[".name"],
remarks=e["remark"]
}
end
end
local e=a:option(DynamicList,"xray_balancing_node",translate("Load balancing node list"),translate("Load balancing node list, <a target='_blank' href='https://toutyrater.github.io/routing/balance2.html'>document</a>"))
t(e,{xray_protocol="_balancing"})
i(e,{xray_protocol="_balancing"})
for a,t in pairs(o)do e:value(t.id,t.remarks)end
e.cfgvalue=s
e.write=n
local e=a:option(ListValue,"xray_balancingStrategy",translate("Balancing Strategy"))
t(e,{xray_protocol="_balancing"})
i(e,{xray_protocol="_balancing"})
e:value("random")
e:value("leastPing")
e.default="random"
e.cfgvalue=s
e.write=n
local e=a:option(Flag,"xray_useCustomProbeUrl",translate("Use Custome Probe URL"),translate("By default the built-in probe URL will be used, enable this option to use a custom probe URL."))
t(e,{xray_balancingStrategy="leastPing"})
i(e,{xray_balancingStrategy="leastPing"})
e.cfgvalue=s
e.write=n
local e=a:option(Value,"xray_probeUrl",translate("Probe URL"))
t(e,{xray_useCustomProbeUrl=true})
i(e,{xray_useCustomProbeUrl=true})
e.default="https://www.google.com/generate_204"
e.description=translate("The URL used to detect the connection status.")
e.cfgvalue=s
e.write=n
local e=a:option(Value,"xray_probeInterval",translate("Probe Interval"))
t(e,{xray_balancingStrategy="leastPing"})
i(e,{xray_balancingStrategy="leastPing"})
e.default="1m"
e.description=translate("The interval between initiating probes. Every time this time elapses, a server status check is performed on a server. The time format is numbers + units, such as '10s', '2h45m', and the supported time units are <code>ns</code>, <code>us</code>, <code>ms</code>, <code>s</code>, <code>m</code>, <code>h</code>, which correspond to nanoseconds, microseconds, milliseconds, seconds, minutes, and hours, respectively.")
e.cfgvalue=s
e.write=n
if#o>0 then
e=a:option(Flag,"preproxy_enabled",translate("Preproxy"))
t(e,{xray_protocol="_shunt"})
i(e,{xray_protocol="_shunt"})
e=a:option(Value,"main_node",string.format('<a style="color:red">%s</a>',translate("Preproxy Node")),translate("Set the node to be used as a pre-proxy. Each rule (including <code>Default</code>) has a separate switch that controls whether this rule uses the pre-proxy or not."))
t(e,{xray_protocol="_shunt",preproxy_enabled=true})
i(e,{xray_protocol="_shunt",preproxy_enabled=true})
for a,t in pairs(d)do
e:value(t.id,t.remarks)
end
for a,t in pairs(l)do
e:value(t.id,t.remarks)
end
for a,t in pairs(o)do
e:value(t.id,t.remarks)
end
e.default="nil"
end
c:foreach(m,"shunt_rules",function(n)
if n[".name"]and n.remarks then
e=a:option(Value,n[".name"],string.format('* <a href="%s" target="_blank">%s</a>',h.url("shunt_rules",n[".name"]),n.remarks))
e:value("nil",translate("Close"))
e:value("_default",translate("Default"))
e:value("_direct",translate("Direct Connection"))
e:value("_blackhole",translate("Blackhole"))
t(e,{xray_protocol="_shunt"})
i(e,{xray_protocol="_shunt"})
if#o>0 then
for a,t in pairs(d)do
e:value(t.id,t.remarks)
end
for a,t in pairs(l)do
e:value(t.id,t.remarks)
end
local a=a:option(ListValue,n[".name"].."_proxy_tag",string.format('* <a style="color:red">%s</a>',n.remarks.." "..translate("Preproxy")))
a:value("nil",translate("Close"))
a:value("main",translate("Preproxy Node"))
a.default="nil"
for s,o in pairs(o)do
e:value(o.id,o.remarks)
t(a,{xray_protocol="_shunt",preproxy_enabled="1",[n[".name"]]=o.id})
i(a,{xray_protocol="_shunt",preproxy_enabled="1",[n[".name"]]=o.id})
end
end
end
end)
e=a:option(DummyValue,"shunt_tips"," ")
e.rawhtml=true
e.cfgvalue=function(e,e)
return string.format('<a style="color: red" href="../rule">%s</a>',translate("No shunt rules? Click me to go to add."))
end
t(e,{xray_protocol="_shunt"})
local e=a:option(Value,"default_node",string.format('* <a style="color:red">%s</a>',translate("Default")))
t(e,{xray_protocol="_shunt"})
e:value("_direct",translate("Direct Connection"))
e:value("_blackhole",translate("Blackhole"))
if#o>0 then
for a,t in pairs(d)do
e:value(t.id,t.remarks)
end
for a,t in pairs(l)do
e:value(t.id,t.remarks)
end
local a=a:option(ListValue,"default_proxy_tag",string.format('* <a style="color:red">%s</a>',translate("Default Preproxy")),translate("When using, localhost will connect this node first and then use this node to connect the default node."))
a:value("nil",translate("Close"))
a:value("main",translate("Preproxy Node"))
a.default="nil"
for i,o in pairs(o)do
e:value(o.id,o.remarks)
t(a,{xray_protocol="_shunt",preproxy_enabled="1",default_node=o.id})
end
end
e=a:option(ListValue,"domainStrategy",translate("Domain Strategy"))
e:value("AsIs")
e:value("IPIfNonMatch")
e:value("IPOnDemand")
e.default="IPOnDemand"
e.description="<br /><ul><li>"..translate("'AsIs': Only use domain for routing. Default value.")
.."</li><li>"..translate("'IPIfNonMatch': When no rule matches current domain, resolves it into IP addresses (A or AAAA records) and try all rules again.")
.."</li><li>"..translate("'IPOnDemand': As long as there is a IP-based rule, resolves the domain into IP immediately.")
.."</li></ul>"
t(e,{xray_protocol="_shunt"})
e=a:option(ListValue,"domainMatcher",translate("Domain matcher"))
e:value("hybrid")
e:value("linear")
t(e,{xray_protocol="_shunt"})
e=a:option(Value,"xray_address",translate("Address (Support Domain Name)"))
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless"})
t(e,{xray_protocol="http"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="trojan"})
t(e,{xray_protocol="wireguard"})
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
i(e,{xray_protocol="http"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="trojan"})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_port",translate("Port"))
e.datatype="port"
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless"})
t(e,{xray_protocol="http"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="trojan"})
t(e,{xray_protocol="wireguard"})
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
i(e,{xray_protocol="http"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="trojan"})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_username",translate("Username"))
t(e,{xray_protocol="http"})
t(e,{xray_protocol="socks"})
i(e,{xray_protocol="http"})
i(e,{xray_protocol="socks"})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_password",translate("Password"))
e.password=true
t(e,{xray_protocol="http"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="trojan"})
i(e,{xray_protocol="http"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="trojan"})
e.cfgvalue=s
e.write=n
e=a:option(ListValue,"security",translate("Encrypt Method"))
for o,a in ipairs(w)do e:value(a)end
t(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vmess"})
e=a:option(Value,"encryption",translate("Encrypt Method"))
e.default="none"
e:value("none")
t(e,{xray_protocol="vless"})
i(e,{xray_protocol="vless"})
e=a:option(ListValue,"v_ss_encrypt_method",translate("Encrypt Method"))
for a,t in ipairs(y)do e:value(t)end
i(e,{xray_protocol="shadowsocks"})
function e.cfgvalue(t,e)
return r:get(e,"method")
end
function e.write(o,a,t)
r:set(a,"method",t)
end
e=a:option(ListValue,"x_ss_encrypt_method",translate("Encrypt Method"))
for o,a in ipairs(f)do e:value(a)end
t(e,{xray_protocol="shadowsocks"})
function e.cfgvalue(t,e)
return r:get(e,"method")
end
function e.write(o,a,t)
r:set(a,"method",t)
end
e=a:option(Flag,"iv_check",translate("IV Check"))
i(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="aes-128-gcm"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="aes-256-gcm"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="chacha20-poly1305"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="xchacha20-poly1305"})
e=a:option(Flag,"uot",translate("UDP over TCP"),translate("Need Xray-core or sing-box as server side."))
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="2022-blake3-aes-128-gcm"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="2022-blake3-aes-256-gcm"})
t(e,{xray_protocol="shadowsocks",x_ss_encrypt_method="2022-blake3-chacha20-poly1305"})
e=a:option(Value,"xray_uuid",translate("ID"))
e.password=true
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless"})
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
e.cfgvalue=s
e.write=n
e=a:option(Flag,"xray_tls",translate("TLS"))
e.default=0
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="trojan"})
t(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="trojan"})
i(e,{xray_protocol="shadowsocks"})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_tlsflow",translate("flow"))
e.default=""
e:value("",translate("Disable"))
e:value("xtls-rprx-vision")
e:value("xtls-rprx-vision-udp443")
t(e,{xray_protocol="vless",xray_tls=true,transport="tcp"})
e.cfgvalue=s
e.write=n
e=a:option(Flag,"reality",translate("REALITY"),translate("Only recommend to use with VLESS-TCP-XTLS-Vision."))
e.default=0
t(e,{xray_tls=true,transport="tcp"})
t(e,{xray_tls=true,transport="h2"})
t(e,{xray_tls=true,transport="grpc"})
e=a:option(ListValue,"alpn",translate("alpn"))
e.default="default"
e:value("default",translate("Default"))
e:value("h2,http/1.1")
e:value("h2")
e:value("http/1.1")
t(e,{xray_tls=true,reality=false})
i(e,{xray_tls=true})
e=a:option(Value,"xray_tls_serverName",translate("Domain"))
t(e,{xray_tls=true})
i(e,{xray_tls=true})
e.cfgvalue=s
e.write=n
e=a:option(Flag,"xray_tls_allowInsecure",translate("allowInsecure"),translate("Whether unsafe connections are allowed. When checked, Certificate validation will be skipped."))
e.default="0"
t(e,{xray_tls=true,reality=false})
i(e,{xray_tls=true})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_fingerprint",translate("Finger Print"),translate("Avoid using randomized, unless you have to."))
e:value("",translate("Disable"))
e:value("chrome")
e:value("firefox")
e:value("safari")
e:value("ios")
e:value("edge")
e:value("qq")
e:value("random")
e:value("randomized")
e.default=""
t(e,{xray_tls=true,reality=false})
e.cfgvalue=s
e.write=n
e.remove=p
e=a:option(Value,"reality_publicKey",translate("Public Key"))
t(e,{xray_tls=true,reality=true})
e=a:option(Value,"reality_shortId",translate("Short Id"))
t(e,{xray_tls=true,reality=true})
e=a:option(Value,"reality_spiderX",translate("Spider X"))
e.placeholder="/"
t(e,{xray_tls=true,reality=true})
e=a:option(Value,"reality_fingerprint",translate("Finger Print"),translate("Avoid using randomized, unless you have to."))
e:value("chrome")
e:value("firefox")
e:value("safari")
e:value("ios")
e:value("edge")
e:value("qq")
e:value("random")
e:value("randomized")
e.default="chrome"
t(e,{xray_tls=true,reality=true})
function e.cfgvalue(t,e)
return r:get(e,"fingerprint")
end
function e.write(o,t,a)
r:set(t,"fingerprint",a)
end
e=a:option(ListValue,"transport",translate("Transport"))
e:value("tcp","TCP")
e:value("mkcp","mKCP")
e:value("ws","WebSocket")
e:value("h2","HTTP/2")
e:value("ds","DomainSocket")
e:value("quic","QUIC")
e:value("grpc","gRPC")
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="trojan"})
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="trojan"})
e=a:option(Value,"wireguard_public_key",translate("Public Key"))
t(e,{xray_protocol="wireguard"})
e=a:option(Value,"wireguard_secret_key",translate("Private Key"))
t(e,{xray_protocol="wireguard"})
e=a:option(Value,"wireguard_preSharedKey",translate("Pre shared key"))
t(e,{xray_protocol="wireguard"})
e=a:option(DynamicList,"wireguard_local_address",translate("Local Address"))
t(e,{xray_protocol="wireguard"})
e=a:option(Value,"wireguard_mtu",translate("MTU"))
e.default="1420"
t(e,{xray_protocol="wireguard"})
if h.compare_versions(h.get_app_version("xray"),">=","1.8.0")then
e=a:option(Value,"wireguard_reserved",translate("Reserved"),translate("Decimal numbers separated by \",\" or Base64-encoded strings."))
t(e,{xray_protocol="wireguard"})
end
e=a:option(Value,"wireguard_keepAlive",translate("Keep Alive"))
e.default="0"
t(e,{xray_protocol="wireguard"})
e=a:option(ListValue,"tcp_guise",translate("Camouflage Type"))
e:value("none","none")
e:value("http","http")
t(e,{transport="tcp"})
i(e,{transport="tcp"})
e=a:option(DynamicList,"tcp_guise_http_host",translate("HTTP Host"))
t(e,{tcp_guise="http"})
i(e,{tcp_guise="http"})
e=a:option(DynamicList,"tcp_guise_http_path",translate("HTTP Path"))
e.placeholder="/"
t(e,{tcp_guise="http"})
i(e,{tcp_guise="http"})
e=a:option(ListValue,"mkcp_guise",translate("Camouflage Type"),translate('<br />none: default, no masquerade, data sent is packets with no characteristics.<br />srtp: disguised as an SRTP packet, it will be recognized as video call data (such as FaceTime).<br />utp: packets disguised as uTP will be recognized as bittorrent downloaded data.<br />wechat-video: packets disguised as WeChat video calls.<br />dtls: disguised as DTLS 1.2 packet.<br />wireguard: disguised as a WireGuard packet. (not really WireGuard protocol)'))
for o,a in ipairs(u)do e:value(a)end
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_mtu",translate("KCP MTU"))
e.default="1350"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_tti",translate("KCP TTI"))
e.default="20"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_uplinkCapacity",translate("KCP uplinkCapacity"))
e.default="5"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_downlinkCapacity",translate("KCP downlinkCapacity"))
e.default="20"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Flag,"mkcp_congestion",translate("KCP Congestion"))
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_readBufferSize",translate("KCP readBufferSize"))
e.default="1"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_writeBufferSize",translate("KCP writeBufferSize"))
e.default="1"
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"mkcp_seed",translate("KCP Seed"))
t(e,{transport="mkcp"})
i(e,{transport="mkcp"})
e=a:option(Value,"xray_ws_host",translate("WebSocket Host"))
t(e,{transport="ws"})
t(e,{ss_transport="ws"})
i(e,{transport="ws"})
i(e,{ss_transport="ws"})
e.cfgvalue=s
e.write=n
e=a:option(Value,"xray_ws_path",translate("WebSocket Path"))
e.placeholder="/"
t(e,{transport="ws"})
t(e,{ss_transport="ws"})
i(e,{transport="ws"})
i(e,{ss_transport="ws"})
e.cfgvalue=s
e.write=n
e=a:option(Flag,"ws_enableEarlyData",translate("Enable early data"))
i(e,{transport="ws"})
e=a:option(Value,"ws_maxEarlyData",translate("Early data length"))
e.default="1024"
i(e,{ws_enableEarlyData=true})
e=a:option(Value,"ws_earlyDataHeaderName",translate("Early data header name"),translate("Recommended value: Sec-WebSocket-Protocol"))
i(e,{ws_enableEarlyData=true})
e=a:option(Value,"xray_h2_host",translate("HTTP/2 Host"))
t(e,{transport="h2"})
t(e,{ss_transport="h2"})
i(e,{transport="h2"})
i(e,{ss_transport="h2"})
e=a:option(Value,"xray_h2_path",translate("HTTP/2 Path"))
e.placeholder="/"
t(e,{transport="h2"})
t(e,{ss_transport="h2"})
i(e,{transport="h2"})
i(e,{ss_transport="h2"})
e=a:option(Flag,"h2_health_check",translate("Health check"))
t(e,{transport="h2"})
e=a:option(Value,"h2_read_idle_timeout",translate("Idle timeout"))
e.default="10"
t(e,{h2_health_check=true})
e=a:option(Value,"h2_health_check_timeout",translate("Health check timeout"))
e.default="15"
t(e,{h2_health_check=true})
e=a:option(Value,"ds_path","Path",translate("A legal file path. This file must not exist before running."))
t(e,{transport="ds"})
i(e,{transport="ds"})
e=a:option(ListValue,"quic_security",translate("Encrypt Method"))
e:value("none")
e:value("aes-128-gcm")
e:value("chacha20-poly1305")
t(e,{transport="quic"})
i(e,{transport="quic"})
e=a:option(Value,"quic_key",translate("Encrypt Method")..translate("Key"))
t(e,{transport="quic"})
i(e,{transport="quic"})
e=a:option(ListValue,"quic_guise",translate("Camouflage Type"))
for o,a in ipairs(u)do e:value(a)end
t(e,{transport="quic"})
i(e,{transport="quic"})
e=a:option(Value,"grpc_serviceName","ServiceName")
t(e,{transport="grpc"})
i(e,{transport="grpc"})
e=a:option(ListValue,"grpc_mode","gRPC "..translate("Transfer mode"))
e:value("gun")
e:value("multi")
t(e,{transport="grpc"})
e=a:option(Flag,"grpc_health_check",translate("Health check"))
t(e,{transport="grpc"})
e=a:option(Value,"grpc_idle_timeout",translate("Idle timeout"))
e.default="10"
t(e,{grpc_health_check=true})
e=a:option(Value,"grpc_health_check_timeout",translate("Health check timeout"))
e.default="20"
t(e,{grpc_health_check=true})
e=a:option(Flag,"grpc_permit_without_stream",translate("Permit without stream"))
e.default="0"
t(e,{grpc_health_check=true})
e=a:option(Value,"grpc_initial_windows_size",translate("Initial Windows Size"))
e.default="0"
t(e,{transport="grpc"})
e=a:option(Flag,"mux",translate("Mux"))
i(e,{xray_protocol="vmess"})
i(e,{xray_protocol="vless"})
i(e,{xray_protocol="http"})
i(e,{xray_protocol="socks"})
i(e,{xray_protocol="shadowsocks"})
i(e,{xray_protocol="trojan"})
t(e,{xray_protocol="vmess"})
t(e,{xray_protocol="vless",xray_tlsflow=""})
t(e,{xray_protocol="http"})
t(e,{xray_protocol="socks"})
t(e,{xray_protocol="shadowsocks"})
t(e,{xray_protocol="trojan"})
e=a:option(Value,"mux_concurrency",translate("Mux concurrency"))
e.default=8
t(e,{mux=true})
i(e,{mux=true})
e=a:option(Flag,"xmux",translate("xMux"))
e.default=1
t(e,{xray_protocol="vless",xray_tlsflow="xtls-rprx-vision"})
t(e,{xray_protocol="vless",xray_tlsflow="xtls-rprx-vision-udp443"})
e=a:option(Value,"xudp_concurrency",translate("XUDP Mux concurrency"))
e.default=8
t(e,{xmux=true})
a.fields["xray_protocol"].validate=function(t,e)
if e=="_shunt"or e=="_balancing"then
a.fields["xray_address"].rmempty=true
a.fields["xray_port"].rmempty=true
end
return e
end
