module("luci.passwall.api",package.seeall)
local o=require"luci.passwall.com"
bin=require"nixio".bin
fs=require"nixio.fs"
sys=require"luci.sys"
uci=require"luci.model.uci".cursor()
util=require"luci.util"
datatypes=require"luci.cbi.datatypes"
jsonc=require"luci.jsonc"
i18n=require"luci.i18n"
appname="passwall"
curl_args={"-skfL","--connect-timeout 3","--retry 3","-m 60"}
command_timeout=300
OPENWRT_ARCH=nil
DISTRIB_ARCH=nil
LOG_FILE="/tmp/log/"..appname..".log"
CACHE_PATH="/tmp/etc/"..appname.."_tmp"
function log(...)
local t=os.date("%Y-%m-%d %H:%M:%S: ")..table.concat({...}," ")
local e,a=io.open(LOG_FILE,"a")
if e and a==nil then
e:write(t.."\n")
e:close()
end
end
function exec_call(e)
local a=io.popen(e..'; echo -e "\n$?"')
local e={}
local t=""
local o
for t in a:lines()do
e[#e+1]=t
end
a:close()
if#e>0 then
o=e[#e]
for a=1,#e-1 do
t=t..e[a]..((a==#e-1)and""or"\n")
end
end
return tonumber(o),trim(t)
end
function base64Decode(e)
local a=e
if not e then return''end
e=e:gsub("%z","")
e=e:gsub("%c","")
e=e:gsub("_","/")
e=e:gsub("-","+")
local t=#e%4
e=e..string.sub('====',t+1)
local e=nixio.bin.b64decode(e)
if e then
return e:gsub("%z","")
else
return a
end
end
function curl_base(a,t,e)
if not e then e={}end
if t then
e[#e+1]="-o "..t
end
local e=string.format('curl %s "%s"',table_join(e),a)
return exec_call(e)
end
function curl_proxy(a,o,e)
local t=luci.sys.exec("[ -f /tmp/etc/passwall/TCP_SOCKS_server ] && echo -n $(cat /tmp/etc/passwall/TCP_SOCKS_server) || echo -n ''")
if t~=""then
if not e then e={}end
local e=clone(e)
e[#e+1]="-x socks5h://"..t
return curl_base(a,o,e)
end
return nil,nil
end
function curl_logic(a,t,o)
local e,i=curl_proxy(a,t,o)
if not e or e~=0 then
e,i=curl_base(a,t,o)
end
return e,i
end
function url(...)
local e=string.format("admin/services/%s",appname)
local t={...}
for a,t in pairs(t)do
if t~=""then
e=e.."/"..t
end
end
return require"luci.dispatcher".build_url(e)
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function is_exist(e,t)
for a,e in ipairs(e)do
if e==t then
return true
end
end
return false
end
function repeat_exist(t,a)
local e=0
for o,t in ipairs(t)do
if t:find("-")and t==a then
e=e+1
end
end
if e>1 then
return true
end
return false
end
function remove(...)
for t,e in ipairs({...})do
if e and#e>0 and e~="/"then
sys.call(string.format("rm -rf %s",e))
end
end
end
function is_install(e)
if e and#e>0 then
return sys.call(string.format('opkg list-installed | grep "%s" > /dev/null 2>&1',e))==0
end
return false
end
function get_args(t)
local a={}
for e,o in pairs(t)do
if e>0 then
local e=t[e+1]
if e then
if repeat_exist(t,e)==false then
a[o]=e
end
end
end
end
return a
end
function get_function_args(e)
local a=nil
if e and#e>1 then
local t={}
for o=2,#e do
t[#t+1]=e[o]
end
a=get_args(t)
end
return a
end
function strToTable(e)
if e==nil or type(e)~="string"then
return{}
end
return loadstring("return "..e)()
end
function is_normal_node(e)
if e and e.type and e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
return false
end
return true
end
function is_special_node(e)
return is_normal_node(e)==false
end
function is_ip(e)
if is_ipv6(e)then
e=get_ipv6_only(e)
end
return datatypes.ipaddr(e)
end
function is_ipv6(e)
local t=e
local e=e:match('%[(.*)%]')
if e then
t=e
end
if datatypes.ip6addr(t)then
return true
end
return false
end
function is_ipv6addrport(e)
if is_ipv6(e)then
local t,e=e:match('%[(.*)%]:([^:]+)$')
if e then
return datatypes.port(e)
end
end
return false
end
function get_ipv6_only(e)
local t=""
if is_ipv6(e)then
t=e
if e:match('%[(.*)%]')then
t=e:match('%[(.*)%]')
end
end
return t
end
function get_ipv6_full(t)
local e=""
if is_ipv6(t)then
e=t
if not t:match('%[(.*)%]')then
e="["..e.."]"
end
end
return e
end
function get_ip_type(e)
if is_ipv6(e)then
return"6"
elseif datatypes.ip4addr(e)then
return"4"
end
return""
end
function is_mac(e)
return datatypes.macaddr(e)
end
function ip_or_mac(e)
if e then
if get_ip_type(e)=="4"then
return"ip"
end
if is_mac(e)then
return"mac"
end
end
return""
end
function iprange(e)
if e then
local t,e=e:match("^([^/]+)-([^/]+)$")
if(t and datatypes.ip4addr(t))and(e and datatypes.ip4addr(e))then
return true
end
end
return false
end
function get_domain_from_url(e)
local t=string.match(e,"//([^/]+)")
if t then
return t
end
return e
end
function get_valid_nodes()
local i=uci_get_type("global_other","nodes_ping")or""
local o={}
uci:foreach(appname,"nodes",function(e)
e.id=e[".name"]
if e.type and e.remarks then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
e["remark"]="%s：[%s] "%{e.type.." "..i18n.translatef(e.protocol),e.remarks}
e["node_type"]="special"
o[#o+1]=e
end
if e.port and e.address then
local t=e.address
if is_ip(t)or datatypes.hostname(t)then
local a=e.type
if(a=="V2ray"or a=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
if is_ipv6(t)then t=get_ipv6_full(t)end
e["remark"]="%s：[%s]"%{a,e.remarks}
if i:find("info")then
e["remark"]="%s：[%s] %s:%s"%{a,e.remarks,t,e.port}
end
e.node_type="normal"
o[#o+1]=e
end
end
end
end)
return o
end
function get_node_remarks(e)
local t=""
if e then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface")then
t="%s：[%s] "%{e.type.." "..i18n.translatef(e.protocol),e.remarks}
else
local a=e.type
if(e.type=="V2ray"or e.type=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
t="%s：[%s]"%{a,e.remarks}
end
end
return t
end
function get_full_node_remarks(e)
local t=get_node_remarks(e)
if#t>0 then
if e.address and e.port then
t=t.." "..e.address..":"..e.port
end
end
return t
end
function gen_uuid(t)
local e=sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")
if t==nil then
e=string.gsub(e,"-","")
end
return e
end
function gen_short_uuid()
return sys.exec("echo -n $(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 8)")
end
function uci_get_type(a,t,e)
local t=uci:get_first(appname,a,t,e)or sys.exec("echo -n $(uci -q get "..appname..".@"..a.."[0]."..t..")")
if(t==nil or t=="")and(e and e~="")then
t=e
end
return t
end
function uci_get_type_id(a,e,t)
local e=uci:get(appname,a,e,t)or sys.exec("echo -n $(uci -q get "..appname.."."..a.."."..e..")")
if(e==nil or e=="")and(t and t~="")then
e=t
end
return e
end
local function n(e)
if e and e~=""then
if not fs.access(e,"rwx","rx","rx")then
fs.chmod(e,755)
end
end
end
function get_customed_path(e)
return uci_get_type("global_app",e.."_file")
end
function is_finded(e)
return luci.sys.exec('type -t -p "/bin/%s" -p "/usr/bin/%s" -p "%s" "%s"'%{e,e,get_customed_path(e),e})~=""and true or false
end
function clone(i)
local function o(e,a)
for e,t in pairs(e)do
if type(t)~="table"then
a[e]=t;
else
a[e]={};
o(t,a[e])
end
end
end
local e={}
o(i,e)
return e
end
local function a(e,a)
sys.call("mkdir -p /tmp/etc/passwall_tmp")
if fs.access(e)then
n(e)
local t=sys.exec("echo -n $(md5sum "..e.." | awk '{print $1}')")
if fs.access("/tmp/etc/passwall_tmp/"..t)then
return sys.exec("echo -n $(cat /tmp/etc/passwall_tmp/%s)"%t)
else
local e=sys.exec(string.format("echo -n $(%s %s)",e,a))
if e and e~=""then
sys.call("echo '"..e.."' > ".."/tmp/etc/passwall_tmp/"..t)
return e
end
end
end
return""
end
function get_app_path(e)
local t=o[e].default_path
local e=uci_get_type("global_app",e:gsub("%-","_").."_file")
e=e and(#e>0 and e or t)or t
return e
end
function get_app_version(t,e)
if e==nil then e=get_app_path(t)end
return a(e,o[t].cmd_version)
end
local function e(e)
if e and#e>1 then
if sys.exec('[ -f "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function t(e)
if e and#e>1 then
if sys.exec('[ -d "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function l(e)
if t(e)then
return e
else
return l(fs.dirname(e))
end
end
local function h(e)
if e==nil then e="/"end
if sys.call("df -k "..e.." >/dev/null 2>&1")==0 then
return tonumber(sys.exec("echo -n $(df -k "..e.." | awk 'NR>1' | awk '{print $4}')"))
end
return 0
end
local function r(e)
if e==nil then return 0 end
if fs.access(e)then
return tonumber(sys.exec("echo -n $(du -k "..e.." | awk '{print $1}')"))
end
return 0
end
function _unpack(t,e)
e=e or 1
if t[e]~=nil then return t[e],_unpack(t,e+1)end
end
function table_join(a,e)
if not e then
e=" "
end
local t=""
for o,i in ipairs(a)do
t=t..a[o]..(o==#a and""or e)
end
return t
end
local function t(h,r,i,o)
local a=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if i or o then
local n=a.time()
while true do
if o and a.difftime(a.time(),n)>=o then
e.kill(t,e.const.SIGTERM)
return 1
end
if i then
local e=s:read(2048)
if e and#e>0 then
i(e)
end
end
local n,t,a=e.waitpid(t,"nohang")
if n and t=="exited"then return a end
if not i and o then e.nanosleep(1)end
end
else
local a,t,e=e.waitpid(t)
return a and t=="exited"and e
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(h,r,nil)
e.stdout:close()
a.exit(1)
end
end
function compare_versions(a,e,t)
local o=table
if not a then a=""end
if not t then t=""end
local n=util.split(a,"[%.%-]",nil,true)
local i=util.split(t,"[%.%-]",nil,true)
local t=o.getn(n)
local a=o.getn(i)
if(t<a)then t=a end
for a=1,t,1 do
local t=tonumber(n[a]or 0)or 0
local a=tonumber(i[a]or 0)or 0
if e=="~="and(t~=a)then return true end
if(e=="<"or e=="<=")and(t<a)then return true end
if(e==">"or e==">=")and(t>a)then return true end
if(t~=a)then return false end
end
return not(e=="<"or e==">")
end
local function n()
local e=nixio.uname().machine or""
if not OPENWRT_ARCH and fs.access("/usr/lib/os-release")then
OPENWRT_ARCH=sys.exec("echo -n $(grep 'OPENWRT_ARCH' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
if OPENWRT_ARCH==""then OPENWRT_ARCH=nil end
end
if not DISTRIB_ARCH and fs.access("/etc/openwrt_release")then
DISTRIB_ARCH=sys.exec("echo -n $(grep 'DISTRIB_ARCH' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
if DISTRIB_ARCH==""then DISTRIB_ARCH=nil end
end
if e:match("^i[%d]86$")then
e="x86"
elseif e:match("armv5")then
e="armv5"
elseif e:match("armv6")then
e="armv6"
elseif e:match("armv7")then
e="armv7"
end
if OPENWRT_ARCH or DISTRIB_ARCH then
if e=="mips"then
if OPENWRT_ARCH and OPENWRT_ARCH:match("mipsel")=="mipsel"
or DISTRIB_ARCH and DISTRIB_ARCH:match("mipsel")=="mipsel"then
e="mipsel"
end
elseif e=="armv7"then
if OPENWRT_ARCH and not OPENWRT_ARCH:match("vfp")and not OPENWRT_ARCH:match("neon")
or DISTRIB_ARCH and not DISTRIB_ARCH:match("vfp")and not DISTRIB_ARCH:match("neon")then
e="armv5"
end
end
end
return util.trim(e)
end
function parseURL(e)
if not e or e==""then
return nil
end
local t="^(%w+)://"
local a=e:match(t)
if not a then
return nil
end
local e=e:sub(#a+4)
local t="^([^@]+)@"
local t=e:match(t)
local i,o
if t then
i,o=t:match("^([^:]+):([^:]+)$")
e=e:sub(#t+2)
end
local e,t=e:match("^([^:]+):(%d+)$")
if not e or not t then
return nil
end
return{
protocol=a,
username=i,
password=o,
host=e,
port=tonumber(t)
}
end
local d={
x86_64="amd64",
x86="386",
aarch64="arm64",
mips="mips",
mipsel="mipsle",
armv5="arm.*5",
armv6="arm.*6[^4]*",
armv7="arm.*7",
armv8="arm64"
}
local function s(e)
local t=require"luci.jsonc"
local a,e=curl_logic(e,nil,curl_args)
if a~=0 or e==""then return{}end
return t.parse(e)or{}
end
local function i(e)
local t=get_app_path(e)or""
if t==""then
return{
code=1,
error=i18n.translatef("You did not fill in the %s path. Please save and apply then update manually.",e)
}
end
return{
code=0,
app_path=t
}
end
function to_check(t,e)
local a=i(e)
if a.code~=0 then
return a
end
if not t or t==""then t=n()end
local t=o[e].file_tree[t]or d[t]or""
if t==""then
return{
code=1,
error=i18n.translate("Can't determine ARCH, or ARCH not supported.")
}
end
local a=get_app_version(e)
local i=string.format(o[e].match_fmt_str,t)
local e=s(o[e]:get_url())
if#e>0 then
e=e[1]
end
if e.tag_name==nil then
return{
code=1,
error=i18n.translate("Get remote version info failed.")
}
end
local o=e.tag_name
local t=compare_versions(a:match("[^v]+"),"<",o:match("[^v]+"))
if not t then
return{
code=0,
local_version=a,
remote_version=o
}
end
local t={}
for a,e in ipairs(e.assets)do
if e.name and e.name:match(i)then
t=e
break
end
end
if not t.browser_download_url then
return{
code=1,
local_version=a,
remote_version=o,
html_url=e.html_url,
data=t,
error=i18n.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
has_update=true,
local_version=a,
remote_version=o,
html_url=e.html_url,
data=t
}
end
function to_download(a,e,n)
local i=i(a)
if i.code~=0 then
return i
end
if not e or e==""then
return{code=1,error=i18n.translate("Download url is required.")}
end
sys.call("/bin/rm -f /tmp/"..a.."_download.*")
local i=util.trim(util.exec("mktemp -u -t "..a.."_download.XXXXXX"))
if n then
local e=h("/tmp")
if tonumber(n)>tonumber(e)then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
end
local s,n=curl_logic(e,i,curl_args)
n=s==0
if not n then
t("/bin/rm",{"-f",i})
return{
code=1,
error=i18n.translatef("File download failed or timed out: %s",e)
}
end
return{code=0,file=i,zip=o[a].zipped}
end
function to_extract(a,e,o)
local o=i(a)
if o.code~=0 then
return o
end
if not e or e==""or not fs.access(e)then
return{code=1,error=i18n.translate("File path required.")}
end
if sys.exec("echo -n $(opkg list-installed | grep -c unzip)")~="1"then
t("/bin/rm",{"-f",e})
return{
code=1,
error=i18n.translate("Not installed unzip, Can't unzip!")
}
end
sys.call("/bin/rm -rf /tmp/"..a.."_extract.*")
local i=r(e)
local o=h("/tmp")
if o<=0 or o<=i then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
local i=util.trim(util.exec("mktemp -d -t "..a.."_extract.XXXXXX"))
local o={}
t("/usr/bin/unzip",{"-o",e,a,"-d",i},
function(e)o[#o+1]=e end)
local a=util.split(table.concat(o))
t("/bin/rm",{"-f",e})
return{code=0,file=i}
end
function to_move(e,s)
local o=i(e)
if o.code~=0 then
return o
end
local a=o.app_path
local i=s
local n="/bin/rm -rf /tmp/"..e.."_download.*"
if fs.stat(s,"type")=="dir"then
i=s.."/"..e
n="/bin/rm -rf /tmp/"..e.."_extract.*"
end
if not s or s==""then
sys.call(n)
return{code=1,error=i18n.translate("Client file is required.")}
end
local s=get_app_version(e,i)
if s==""then
sys.call(n)
return{
code=1,
error=i18n.translate("The client file is not suitable for current device.")..e.."__"..i
}
end
local s=sys.call('pgrep -af "passwall/.*'..e..'" >/dev/null')
if s==0 then
sys.call("/etc/init.d/passwall stop")
end
local d=0
if fs.access(a)then
d=r(a)
end
local u=r(i)
local r=l(a)
local e=h(r)
if e>0 then
e=e+d
if u>e then
sys.call(n)
return{code=1,error=i18n.translatef("%s not enough space.",r)}
end
end
o=t("/bin/mv",{"-f",i,a},nil,command_timeout)==0
sys.call(n)
if s==0 then
sys.call("/etc/init.d/passwall restart >/dev/null 2>&1 &")
end
if not o or not fs.access(a)then
return{
code=1,
error=i18n.translatef("Can't move new file to path: %s",a)
}
end
return{code=0}
end
function get_version()
return sys.exec("echo -n $(opkg info luci-app-passwall |grep 'Version'|awk '{print $2}')")
end
function to_check_self()
local e="https://raw.githubusercontent.com/xiaorouji/openwrt-passwall/luci/luci-app-passwall/Makefile"
local a="/tmp/passwall_makefile"
local o,e=curl_logic(e,a,curl_args)
e=o==0
if not e then
t("/bin/rm",{"-f",a})
return{
code=1,
error=i18n.translatef("Failed")
}
end
local t=get_version()
local e=sys.exec("echo -n $(grep 'PKG_VERSION' /tmp/passwall_makefile|awk -F '=' '{print $2}')")
local a=compare_versions(t,"<",e)
if not a then
return{
code=0,
local_version=t,
remote_version=e
}
end
return{
code=1,
has_update=true,
local_version=t,
remote_version=e,
error=i18n.translatef("The latest version: %s, currently does not support automatic update, if you need to update, please compile or download the ipk and then manually install.",e)
}
end
